'  QArrow Ver. 0.01 by Peter Scheutz 1999.09.28
'
'  Feel free to use, extend and modify.
'  Use "as is". No refund if it makes our cat loose it's tale
'  
'  Qarrow extends Qcanvs to provide a Arrow shaped button.
'  
'  Qarrow has a "Hot" feature, so that color can change when mouse is over the button
'  Hot color is turned ON by the mouse move event, and turned OFF by a timer.
'  The Timer checks if the mouse has gone outside the arrow canvas area.
'  It also has an disabled color, that is used if the canvas is disabled.
'  when toggling the "Enabled" property, be sure to call the arrows "refresh"
'  method to show the color changes.
'
'  Useful Qarrow Properties:
'
'  Orientation 		'see "Qarrow.inc" for orientation constants
'  State As Long		'poll this to get the current state (see "qarrow.inc")
'  ArrowWidth		'Should be aspect 1:2 or 2:1 depending on orientation
'  ArrowHeight
'
'  ArrowColorNormal	'colors for the states' change these in calling code or
'  ArrowColorHot		'directly in "Qarrow.bas" Constructor to make new defaults 
'  ArrowColorDown
'  ArrowColorDisabled
'
'  Bevel			'turnes bevel on and off
' 
'  Notes: Flickering will occur with large arrows, haven't found a way around this.
'
'  The "MidColor" function can be used in other projects:
'  the syntax is: Color1, Color2, tone (a factor between 0 and 1) 0 means only
'  Color1 and 1 means only Color2
 

'$INCLUDE "RAPIDQ.INC" '(must be included before you include qarrow bas in calling code)

$INCLUDE "QARROW.INC"  'constants for Orientation and states

Type QArrow extends QCanvas
  Bevel as Long
  Orientation As Long       
  State As Long
  ArrowColorNormal As Long
  ArrowColorHot As Long
  ArrowColorDown As Long
  ArrowColorDisabled As Long
  OffTimer As QTimer

  Function MidColor(Color1 as long,Color2 as long,tone as single) as long
    Dim Red1 as long
    Dim Green1 as long
    Dim Blue1 as long

    Dim Red2 as long
    Dim Green2 as long
    Dim Blue2 as long

    Dim RedMid as long
    Dim GreenMid as long
    Dim BlueMid as long

    Blue1 =   SHR(Color1 And &HFF0000)  16
    Green1 =  SHR(Color1 And &HFF00) 8
    Red1 =  (Color1 And &HFF)

    Blue2=   SHR (Color2 And &HFF0000) 16
    Green2=  SHR (Color2 And &HFF00) 8
    Red2=  (Color2 And &HFF)

    RedMid=(Red1*(1-tone)+Red2*tone) and  &HFF
    GreenMid=(Green1*(1-tone)+Green2*tone) and  &HFF
    BlueMid=(Blue1*(1-tone)+Blue2*tone) and  &HFF

    QArrow.MidColor=RedMid or (SHL GreenMid  8) or  (SHL BlueMid 16 )

  end Function


  Sub DrawComponent
      Dim BevelColorHilight  as long
      Dim BevelColorShadow as long
      Dim nowColor As Long

      If QArrow.Enabled = False Then
          QArrow.State = -1
      End If


      Select Case QArrow.State
            Case asNormal
               nowColor = QArrow.ArrowColorNormal
            Case asHot
                 nowColor = QArrow.ArrowColorHot
            Case asDown
                 nowColor = QArrow.ArrowColorDown
            Case Else
                 nowColor = QArrow.ArrowColorDisabled
      End Select
      

      If QArrow.Bevel=True then
            BevelColorHilight=QArrow.MidColor(nowColor,&HFFFFFF,0.7)
            BevelColorShadow=QArrow.MidColor(nowColor,0,0.5)

         if  QArrow.State=asDown then
            swap BevelColorHilight,BevelColorShadow
         end if
      end if

      Select Case QArrow.Orientation
        Case aoPointE
              QArrow.line (0,0,QArrow.Width,QArrow.Height/2,nowColor)
              QArrow.line (0,QArrow.Height-1,QArrow.Width,QArrow.Height/2-1,nowColor)
              'QArrow.line (0,0,0,QArrow.Height,nowColor)

              QArrow.Paint QArrow.Width / 2, QArrow.Height / 2, nowColor, nowColor
              if QArrow.Bevel=True then

                  QArrow.line (0,0,QArrow.Width,QArrow.Height/2,BevelColorShadow)
                  QArrow.line (0,QArrow.Height-1,QArrow.Width,QArrow.Height/2-1,BevelColorShadow)
                  QArrow.line (0,0,0,QArrow.Height,BevelColorHilight)

              end if
        Case aoPointW
              QArrow.line (QArrow.Width-1,0,-1,QArrow.Height/2,nowColor)
              QArrow.line (QArrow.Width-1,QArrow.Height-1,-1,QArrow.Height/2-1,nowColor)
              'QArrow.line (QArrow.Width-1,0,QArrow.Width-1,QArrow.Height,nowColor)

              QArrow.Paint QArrow.Width / 2, QArrow.Height / 2, nowColor, nowColor

              if QArrow.Bevel=True then
                  QArrow.line (QArrow.Width-1,0,-1,QArrow.Height/2,BevelColorHilight)
                  QArrow.line (QArrow.Width-1,QArrow.Height-1,-1,QArrow.Height/2-1,BevelColorShadow)
                  QArrow.line (QArrow.Width-1,0,QArrow.Width-1,QArrow.Height,BevelColorShadow)
              end if

        Case aoPointN
              QArrow.line (0,QArrow.Height-1,QArrow.Width/2,-1,nowColor)
              QArrow.line (QArrow.Width-1,QArrow.Height-1,QArrow.Width/2-1,-1,nowColor)
              QArrow.line (0,QArrow.Height-1,QArrow.Width-1,QArrow.Height-1,nowColor)

              QArrow.Paint QArrow.Width / 2, QArrow.Height / 2, nowColor, nowColor

              if QArrow.Bevel=True then
                  QArrow.line (0,QArrow.Height-1,QArrow.Width/2,-1,BevelColorHilight)
                  QArrow.line (QArrow.Width-1,QArrow.Height-1,QArrow.Width/2-1,-1,BevelColorShadow)
                  QArrow.line (0,QArrow.Height-1,QArrow.Width-1,QArrow.Height-1,BevelColorShadow)

              end if

       Case aoPointS
              QArrow.line (0,0,QArrow.Width/2,QArrow.Height,nowColor)
              QArrow.line (QArrow.Width-1,0,QArrow.Width/2-1,QArrow.Height,nowColor)
              'QArrow.line (0,0,QArrow.Width-1,0,nowColor)
              QArrow.Paint QArrow.Width / 2, QArrow.Height / 2, nowColor, nowColor

              if QArrow.Bevel=True then
                  QArrow.line (0,0,QArrow.Width/2,QArrow.Height,BevelColorShadow)
                  QArrow.line (QArrow.Width-1,0,QArrow.Width/2-1,QArrow.Height,BevelColorShadow)
                  QArrow.line (1,0,QArrow.Width-1,0,BevelColorHilight)
              end if

        End Select

  End Sub

  Sub Refresh
      If QArrow.Enabled = True Then
          QArrow.State = asNormal
      End If
      QArrow.DrawComponent
  End Sub

  Function IsInside(x, y, x1, y1, x2, y2) As Long
        QArrow.IsInside = False
        If x >= x1 And x <= x2 Then
          If y1 >= 0 And y <= y2 Then
                 QArrow.IsInside = True
          End If
      End If
   End Function


  EVENT OffTimer.OnTimer

      If QArrow.IsInside(MouseX, MouseY, 0, 0, QArrow.Width, QArrow.Height) = False Then
           QArrow.State = asNormal
           QArrow.DrawComponent
           QArrow.OffTimer.Enabled = False
      End If

  END EVENT
  Event OnPaint
    QArrow.DrawComponent
  END EVENT
  Event OnMouseDown

          If QArrow.State <> asDown Then
              QArrow.State = asDown
              QArrow.DrawComponent
          End If

  END EVENT
   Event OnMouseUp
      If QArrow.State = asDown Then
          QArrow.State = asHot
          QArrow.DrawComponent
      End If

  END EVENT
  Event OnMouseMove
      If QArrow.IsInside(MouseX, MouseY, 0, 0, QArrow.Width, QArrow.Height) = False Then
         'QArrow.OffTimer.Enabled=FALSE
      Else
      If QArrow.State <> asHot And QArrow.State <> asDown Then
          QArrow.State = asHot
          QArrow.DrawComponent
          QArrow.OffTimer.Enabled = True
      End If
        End If
  END EVENT

CONSTRUCTOR
     Bevel=True
     State = asNormal
     Orientation = aoPointE
     ArrowColorNormal = &HB0E0
     ArrowColorHot = &HD0F0
     ArrowColorDown = &HF0
     ArrowColorDisabled = &H999999
     Width = 25
     Height = 50
     OffTimer.Enabled = False
     OffTimer.Interval = 50

END CONSTRUCTOR
     

End Type



